import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Leser einer gemeinsamen Datei.
 * 
 * @author Johannes Neumeyer
 * @version 1.0
 */
class Leser extends Thread
{
    /** aktueller Dateiinhalt **/
    private String aktuellerInhalt;        
    /** Fenster */
    private JFrame fenster;
    /** Anzeigeelement für die Nachricht, dass der Zugriff nicht möglich ist **/
    private JLabel keinZugriff;
    /** Anzeigeelement für den Ausgabetext */
    private JTextArea ausgabeText;

    /**
     * Konstruktor für Objekte der Klasse Leser
     */
    Leser()
    {
        fenster = new JFrame ("Leser");
        fenster.setSize (400, 250);
        fenster.setLayout(null);

        fenster.addWindowListener(new WindowAdapter() {
                @Override public void windowClosing(WindowEvent evt) {
                    LesenBeenden();
                }
            });

        ausgabeText = new JTextArea();
        ausgabeText.setLocation(30, 30);
        ausgabeText.setSize(340, 160);
        ausgabeText.setVisible(true);
        ausgabeText.setOpaque(true);
        ausgabeText.setEditable(false);
        ausgabeText.setBackground(Color.lightGray);
        ausgabeText.setForeground(Color.black);     

        keinZugriff = new JLabel();
        keinZugriff.setLocation(30, 30);
        keinZugriff.setSize(340, 160);
        keinZugriff.setVisible(true);
        keinZugriff.setOpaque(true);
        keinZugriff.setText("Lesezugriff aktuell nicht möglich");

        fenster.add(keinZugriff);
        fenster.setVisible(true);
        this.start();
    }

    /**
     * Der Leser möchte zu lesen beginnen.
     */
    @Override public void run()
    {
        aktuellerInhalt = SharedFile.SharedFileGeben().LesenBeginnen();    
        // Darstellung aktualisieren           
        ausgabeText.setText(aktuellerInhalt);
        fenster.remove(keinZugriff);
        fenster.add(ausgabeText);
        fenster.validate();
        fenster.repaint();
    }

    /**
     * Der Leser beendet das Lesen.
     */
    private void LesenBeenden()
    {
        SharedFile.SharedFileGeben().LesenBeenden();
        fenster.dispose();        
    }
}
