import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Schreiber in eine gemeinsame Datei.
 * 
 * @author Johannes Neumeyer
 * @version 1.0
 */
class Schreiber extends Thread
{
    /** aktueller Dateiinhalt **/
    private String aktuellerInhalt;
    /** Fenster */
    private JFrame fenster;
    /** Anzeigeelement für die Nachricht, dass der Zugriff nicht möglich ist **/
    private JLabel keinZugriff;
    /** Anzeigeelement für den editierbarerText */
    private JTextArea editierbarerText;
    /** Knopf für die Textübernahme */
    private JButton übernehmen;

    /**
     * Konstruktor für Objekte der Klasse Schreiber
     */
    Schreiber()
    {
        keinZugriff = new JLabel();
        keinZugriff.setLocation(30, 30);
        keinZugriff.setSize(340, 160);
        keinZugriff.setVisible(true);
        keinZugriff.setOpaque(true);
        keinZugriff.setText("Schreibzugriff aktuell nicht möglich");

        editierbarerText = new JTextArea();
        editierbarerText.setLocation(30, 30);
        editierbarerText.setSize(340, 160);
        editierbarerText.setVisible(true);

        übernehmen = new JButton("Änderungen speichern");
        übernehmen.setLocation(30, 210);
        übernehmen.setSize(340, 30);        
        übernehmen.setEnabled(true);        
        übernehmen.addActionListener(new ActionListener()
            {
                @Override public void actionPerformed (ActionEvent e)
                {
                    SharedFile.SharedFileGeben().ÄnderungenSpeichern(editierbarerText.getText());                    
                }
            });
        übernehmen.setVisible(true);

        fenster = new JFrame ("Schreiber");
        fenster.setSize (400, 300);
        fenster.setLayout(null);
        fenster.add(keinZugriff);
        fenster.addWindowListener(new WindowAdapter() {
                @Override public void windowClosing(WindowEvent evt) {
                    Beenden();
                }
            });
        fenster.setVisible(true);
        this.start();
    }

    /**
     * Der Schreiber möchte zu schreiben beginnen.
     */
    @Override public void run()
    {
        aktuellerInhalt = SharedFile.SharedFileGeben().SchreibenBeginnen();    
        // Darstellung aktualisieren           
        editierbarerText.setText(aktuellerInhalt);
        fenster.remove(keinZugriff);
        fenster.add(editierbarerText);
        fenster.add(übernehmen);
        fenster.validate();
        fenster.repaint();
    }

    /**
     * Der Schreiber beendet das Schreiben.
     */
    private void Beenden()
    {
        SharedFile.SharedFileGeben().SchreibenBeenden();
        fenster.dispose();        
    }
}
