
/**
 * Zwischen mehreren Benutzern geteilte Datei
 * 
 * @author Johannes Neumeyer
 * @version 1.0
 */
class SharedFile
{
    /** aktueller Dateiinhalt **/
    private String inhalt;
    /** Singleton stellt sicher, dass nur ein Datei-Objekt existiert. **/
    static SharedFile sd;
    /** aktuelle Anzahl der Leser **/
    private int anzahlLeser;
    /** ist gerade ein Schreiber aktiv **/
    private boolean schreiberAktiv;

    /**
     * Konstruktor für Objekte der Klasse SharedFile
     * nach dem Entwurfsmuster Singleton
     */
    private SharedFile()
    {
        inhalt = "Starttext";
        anzahlLeser = 0;
        schreiberAktiv = false;
    }

    /**
     * Gibt das Datei-Objekt nach dem Singleton-Prinzip zurück.
     * @return Dateiobjekt
     */
    static SharedFile SharedFileGeben()
    {
        if (sd == null)
        {
            sd = new SharedFile();
        }            
        return sd;
    }

    /**
     * Ein Leser beginnt zu lesen.
     * @return Dateiinhalt
     */
    synchronized String LesenBeginnen()
    {
        /*
         * hier ergänzen
         */
        return inhalt; // Inhalt zum Lesen zurückgeben
    }

    /**
     * Ein Leser beendet das Lesen.
     */
    synchronized void LesenBeenden()
    {
        /*
         * hier ergänzen
         */        
    }

    /**
     * Ein Schreiber beginnt zu schreiben.
     * @return Dateiinhalt
     */
    synchronized String SchreibenBeginnen()
    {
        /*
         * hier ergänzen
         */
        return inhalt; // Inhalt zum Schreiben zurückgeben
    }

    /**
     * Ein Schreiber speichert vorgenommene Änderungen.
     * @param inhaltNeu neuer Inhalt
     */
    void ÄnderungenSpeichern(String inhaltNeu)
    {
        inhalt = inhaltNeu;   
    }

    /**
     * Ein Schreiber beendet das Schreiben.
     */
    synchronized void SchreibenBeenden()
    {
        /*
         * hier ergänzen
         */        
    }
}
